/*
 * Macchina.java
 *
 * Created on 7 marzo 2008, 19.30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package enigma;

/**
 *
 * @author dario
 */
public class Macchina implements RicettoreInterface {
    
    /** Creates a new instance of Macchina */
    // r1, r2, r3 = TIPO ROTORE
    // i1, i2, i3 = POSIZIONE INIZIALE
    // ris = rispetta minuscole
    // senzarifl = senza il riflettore
    // decr = decrittazione (procede all'incontrario)
    public Macchina(int r1, int r2, int r3, int i1, int i2, int i3, boolean ris, boolean senzarifl, boolean decr) {
        // Devo creare i miei rotori a partire dall'ultimo
        // perché è lui che deve inviare le cose al Ricettore Macchina
        // cioé questa classe
//        riflettore = new Riflettore();
//        rotore3 = new Rotore(riflettore, tipiRotore[r3], i3);
//        rotore2 = new Rotore(rotore3, tipiRotore[r2], i2);
//        rotore1 = new Rotore(rotore2, tipiRotore[r1], i1);
        
        rispetta = ris;
        decripta = decr;
//        System.out.println("Rispetta = " + ris);
        
        // Creo i rotori ed il riflettore
        // Passando i parametri corretti e l'interfaccia del Ricettore che lo PRECEDE
        rotore1 = new Rotore(this, tipiRotore[r1], i1);
        rotore2 = new Rotore(rotore1, tipiRotore[r2], i2);
        rotore3 = new Rotore(rotore2, tipiRotore[r3], i3);
        
        // Macchina creata senza riflettore
        if (senzarifl) {
            // Dopo il rotore3, c'è Macchina
            rotore3.impostaProssimo(this);
        } else {
            // Dopo il rotore3, c'è il riflettore, e il mess torna indietro
            riflettore = new Riflettore();
            riflettore.impostaProssimo(rotore3);
            rotore3.impostaProssimo(riflettore);
        }
        
        
        // Sistemo i rotori dicendo loro chi è il ricettore che li SEGUE
//        riflettore.impostaProssimo(rotore3);
//        rotore3.impostaProssimo(riflettore);
        rotore2.impostaProssimo(rotore3);
        rotore1.impostaProssimo(rotore2);
        
        
        risultato = "";
        
//        System.out.println("PARTENZA");
    }
    
    public void codifica(String t) {
        
        testo = t;
        
        // Invio ogni lettera al rotore e poi la aggiungo al risultato
        char lettera;
        
        for (int i = 0; i < testo.length(); i ++ ) {
            lettera = Character.toUpperCase(testo.charAt(i));
            
            // Se è una lettera, la processo
            if (Character.isLetter(lettera) && (lettera >= 'A') && (lettera <= 'Z')) {
//                System.out.println("\nCodifica di " + lettera);
                // Invio la lettera al primo rotore
                if (!decripta) {
                    rotore1.accettaLetteraAvanti((int)(lettera - 65));
                    rotore1.segnaleGiro();
                } else {
                    rotore3.accettaLetteraIndietro((int)(lettera - 65));
                    rotore1.segnaleGiro();
                }
            }
            // Se non è una lettera, la appendo al risultato
            else {
                risultato = risultato + lettera;
            }
        }
        
    }
    
    public String ritornaRisultato() {
        String risultatoBis ="";
        
//        System.out.println("\nTESTO:\n" + testo);
//        System.out.println("\nRISULTATO:\n" + risultato);
        if (rispetta) {
            // Ripristino maiuscole etc.
            for (int i = 0; i < risultato.length(); i++) {
                if (Character.isLowerCase(testo.charAt(i))) {
//                    System.out.println((char)(testo.charAt(i)) + " è lower case");
                    risultatoBis = risultatoBis + Character.toLowerCase(risultato.charAt(i));
                } else {
                    risultatoBis = risultatoBis + risultato.charAt(i);
                }
            }
        } else {
            risultatoBis = risultato;
        }
//        System.out.println("\nRISULTATOBIS:\n" + risultatoBis);
        return risultatoBis;
    }
    
    public void segnaleGiro() {
        // Di questo, non me ne faccio nulla perché sono... LA MACCHINA!
        // BwahahahaHAHAHA ahahhaHAH!
    }
    
    public void accettaLetteraAvanti(int lettera) {
        risultato = risultato + (char)(lettera + 65);
    }
    
    public void accettaLetteraIndietro(int lettera) {
        risultato = risultato + (char)(lettera + 65);
    }
    
    public void impostaProssimo(RicettoreInterface r) {
        // Non mi serve
    }
    
    private RicettoreInterface rotore1;
    private RicettoreInterface rotore2;
    private RicettoreInterface rotore3;
    private RicettoreInterface riflettore;
    private Boolean rispetta;
    private Boolean decripta;
    private String testo;
    
    private String risultato;
    
    int[][] tipiRotore = {
        {0,2,4,6,8,10,12,14,16,18,20,22,24,1,3,5,7,9,11,13,15,17,19,21,23,25},
        {0,4,8,12,16,20,24,1,5,9,13,17,21,25,2,6,10,14,18,22,3,7,11,15,19,23},
        {5,4,3,2,1,0,11,10,9,8,7,6,17,16,15,14,13,12,23,22,21,20,19,18,25,24},
        {0,8,16,24,1,9,17,25,2,10,19,3,11,18,4,12,19,5,13,20,6,14,21,7,15,22},
        {0,13,1,14,2,15,3,16,4,17,5,18,6,19,7,20,8,21,9,22,10,23,11,24,12,25},
        {0,7,14,20,1,8,15,21,2,9,16,22,3,10,17,23,4,11,18,24,5,12,19,25,6,13},
        {0,4,8,11,14,17,20,23,1,5,9,12,15,18,21,24,2,6,10,13,16,19,22,25,3,7}
    };
}
